diff -uwr source/scripts/dp88_ar.cpp sourceold/scripts/dp88_ar.cpp
--- source/scripts/dp88_ar.cpp	2013-02-19 19:54:31.516601500 +0800
+++ sourceold/scripts/dp88_ar.cpp	2013-01-13 12:06:54.579164100 +0800
@@ -845,10 +845,6 @@
 
 
 
-
-
-
-
 /*------------------------
 AR Miner Script - Base Class
 
@@ -856,197 +852,174 @@
 and implements common functionality used by both scripts
 --------------------------*/
 
-void dp88_Ore_Miner::Created ( GameObject *obj )
-{
-  m_aiState       = MINER_AISTATE_IDLE;
-  m_oreMined      = 0;
-  m_oreValue      = 0;
-
-  m_bUseAI        = ( Get_Int_Parameter ( "Use_AI" ) == 1 ) ? true : false;
-  m_oreCapacity   = Get_Int_Parameter("Ore_Capacity");
-  m_oreMiningTime = Get_Float_Parameter("Ore_Mining_Time");
-  m_oreDumpTime   = Get_Float_Parameter("Ore_Dump_Time");
-
-  m_oreFieldId    = 0;
-  m_oreFieldRand  = 0;
-
-  // Load animation settings
-  m_animations[MINER_ANIM_IDLE]     = Get_Parameter("Idle_Animation");
-  m_animations[MINER_ANIM_MINING]   = Get_Parameter("Mining_Animation");
-  m_animations[MINER_ANIM_DUMPING]  = Get_Parameter("Dump_Animation");
-  m_animSounds[MINER_ANIM_IDLE]     = NULL;
-  m_animSounds[MINER_ANIM_MINING]   = Get_Parameter("Mining_Sound");
-  m_animSounds[MINER_ANIM_DUMPING]  = Get_Parameter("Dump_Sound");
-
-  for ( int i = MINER_ANIM_IDLE; i < MINER_ANIM_DUMPING; ++i )
+void dp88_AR_Miner::Created ( GameObject *obj )
   {
-    if (m_animations[i] != NULL && strlen(m_animations[i]) < 0)
-      m_animations[i] = NULL;
-    if (m_animSounds[i] != NULL && strlen(m_animSounds[i]) < 0)
-      m_animSounds[i] = NULL;
+	oreFieldRand = 0;
+	oreFieldValue = 0;
+	oreLoadLevel = 0;
+	oreValue = 0;
+	animating = false;
+
+	useAI = ( Get_Int_Parameter ( "enableAI" ) == 1 ) ? true : false;
+	aiState = MINER_AISTATE_IDLE;
+
+	/* If this miner is AI controlled then send the ore unload complete event in 10
+	seconds, which will cause the AI to set off towards an ore field. Note that the
+	delay is required to prevent the normal harvester AI taking over */
+	if ( useAI )
+		Commands->Send_Custom_Event( obj, obj, CUSTOM_MINER_UNLOAD_ORE_COMPLETE, 1, (float)Get_Int_Parameter("aiStartDelay") );
+	if (strlen(Get_Parameter("idleAnimation")) > 0)
+		Commands->Set_Animation(obj,Get_Parameter("idleAnimation"),true,0,0,-1,false);
   }
 
-  // Set the initial animation state
-  m_currentAnimId = MINER_ANIM_DUMPING;
-  UpdateAnimation(obj, MINER_ANIM_IDLE);
 
-  /* For AI miners send a message to ourselves to start searching for an ore field - note the delay
-  * which is required to prevent the default harvester AI taking over */
-  if ( m_bUseAI )
-    Commands->Send_Custom_Event( obj, obj, CUSTOM_MINER_AI_SEARCH_FOR_ORE, 1, (float)Get_Int_Parameter("AI_Init_Delay") );
-}
+void dp88_AR_Miner::Custom ( GameObject *obj, int type, int param, GameObject *sender )
+{
+	// Message from an ore field notifying us that we have entered it. Start
+	// collecting ore and call EnteredOreField()
+	if ( type == CUSTOM_MINER_ENTERED_ORE_FIELD && oreLoadLevel < Get_Int_Parameter("loadLevels") )
+	{
+		// Store the value of the ore field and generate a random integer to identify
+		// this trip into the ore field - prevents glitching the timers by entering
+		// and exiting constantly
+		oreFieldValue = param;
+		oreFieldRand = Commands->Get_Random_Int(2,10240);
 
-// -------------------------------------------------------------------------------------------------
+		// Set AI state
+		if ( useAI )
+			aiState = MINER_AISTATE_COLLECTING_ORE;
 
-void dp88_Ore_Miner::Custom ( GameObject *obj, int type, int param, GameObject *sender )
-{
-  // Message from an ore field indicating we have entered it
-  if ( type == CUSTOM_MINER_ENTERED_ORE_FIELD )
-  {
+		// Send message to increase ore load and, if a player vehicle, inform the driver
+		// that we have started collecting ore
+		Commands->Send_Custom_Event ( obj, obj, CUSTOM_MINER_INCREASE_ORE_LOAD, oreFieldRand, Get_Float_Parameter("timePerLoadLevel") );
+		if ( Get_Vehicle_Driver(obj) != NULL )
+			Send_Message_Player ( Get_Vehicle_Driver(obj), 153, 204, 25, "Collecting ore..." );
+
+		// Call EnteredOreField()
     EnteredOreField(obj, sender);
   }
 
 
-  // Message from an ore field indicating we have left it
+	// Message from an ore field notifying us that we have left it. Stop
+	// collecting ore and call ExitedOreField()
   else if ( type == CUSTOM_MINER_EXITED_ORE_FIELD )
   {
+		// Reset ore field parameters
+		oreFieldValue = 0;
+		oreFieldRand = 0;
+
+		// Call ExitedOreField()
     ExitedOreField(obj, sender);
   }
 
 
-  // Message to ourselves to mine another ore load
-  else if ( type == CUSTOM_MINER_INCREASE_ORE_LOAD && param == m_oreFieldRand )
+  // Message to ourselves to increase our ore load
+  else if ( type == CUSTOM_MINER_INCREASE_ORE_LOAD && param == oreFieldRand )
   {
-    GameObject* pOreField = Commands->Find_Object(m_oreFieldId);
-    dp88_Ore_Field* pOreFieldScript = (!pOreField) ? NULL : (dp88_Ore_Field *)(Find_Script_On_Object(pOreField,"dp88_Ore_Field"));
-
     // Unless we are already full increase our load level and the value of our load
-    if ( m_oreMined < m_oreCapacity && pOreFieldScript )
-    {
-      if ( pOreFieldScript->RemoveOre(1) == 1 )
+    if ( oreLoadLevel < Get_Int_Parameter("loadLevels") )
       {
         // Play the mining sound
-        if ( m_animSounds[MINER_ANIM_MINING] != NULL )
-          Commands->Create_Sound(m_animSounds[MINER_ANIM_MINING],Commands->Get_Position(obj),obj);
+      if (strlen(Get_Parameter("miningSound")) > 0)
+        Commands->Create_Sound(Get_Parameter("miningSound"),Commands->Get_Position(obj),obj);
 
-        m_oreMined++;
-        m_oreValue += pOreFieldScript->GetOreValue();
-      }
+      oreLoadLevel++;
+      oreValue += oreFieldValue*Get_Int_Parameter("orePerLoadLevel");
     }
 
     // If we are still not full start send a delayed custom to increase it again
-    if ( m_oreMined < m_oreCapacity && pOreFieldScript && (pOreFieldScript->IsInfinite() || pOreFieldScript->NumOreUnits() > 0) )
-      Commands->Send_Custom_Event ( obj, obj, CUSTOM_MINER_INCREASE_ORE_LOAD, m_oreFieldRand, m_oreMiningTime );
+    if ( oreLoadLevel < Get_Int_Parameter("loadLevels") )
+      Commands->Send_Custom_Event ( obj, obj, CUSTOM_MINER_INCREASE_ORE_LOAD, oreFieldRand, Get_Float_Parameter("timePerLoadLevel") );
 
 
-    // Otherwise we are full of ore... or the ore field is depleted...
+    // Otherwise we are full of ore...
     else
     {
-      UpdateAnimation(obj, MINER_ANIM_IDLE);
-
+      // Stop the mining animation
+      animating = false;
+      obj->As_PhysicalGameObj()->Clear_Animation();
+      if (strlen(Get_Parameter("idleAnimation")) > 0)
+         Commands->Set_Animation(obj,Get_Parameter("idleAnimation"),true,0,0,-1,false);
       // If using the AI start driving to the refinery
-      if ( m_bUseAI )
+      if ( useAI )
+      {
+        aiState = MINER_AISTATE_RETURN_TO_REFINERY;
         ReturnToRefinery(obj);
+      }
 
       // Or, if we are a player driven miner, tell the driver we are full
       else if ( Get_Vehicle_Driver(obj) != NULL )
-      {
-        if ( m_oreMined < m_oreCapacity )
-          Send_Message_Player ( Get_Vehicle_Driver(obj), DP88_RGB_GENERAL_MSG, "The ore field is depleted, find another ore field or dock at the Refinery to smelt the ore you have collected so far..." );
-        else
           Send_Message_Player ( Get_Vehicle_Driver(obj), DP88_RGB_GENERAL_MSG, "Fully loaded with ore, dock at the Refinery to smelt the ore into credits" );
       }
     }
-  }
 
 
   // Message from the ore dump zone notifying us that we have entered it. If
   // we have ore to unload then immobilize the vehicle and begin unloading it
-  else if ( type == CUSTOM_MINER_ENTERED_DUMP_ZONE && m_oreMined > 0 )
+	else if ( type == CUSTOM_MINER_ENTERED_DUMP_ZONE && oreLoadLevel > 0 )
   {
     // Inform driver we are unloading
     if ( Get_Vehicle_Driver(obj) != NULL )
       Send_Message_Player ( Get_Vehicle_Driver(obj), DP88_RGB_GENERAL_MSG, "Unloading ore, please stand by..." );
 
     // Set AI state
-    if ( m_bUseAI )
-      m_aiState = MINER_AISTATE_UNLOADING_ORE;
+		if ( useAI )
+			aiState = MINER_AISTATE_UNLOADING_ORE;
 
     // Send a timed event to notify us when the ore unload is completed and
     // call the DockedAtRefinery() event
-    Commands->Send_Custom_Event ( obj, obj, CUSTOM_MINER_UNLOAD_ORE_COMPLETE, 0, m_oreDumpTime );
+		Commands->Send_Custom_Event ( obj, obj, CUSTOM_MINER_UNLOAD_ORE_COMPLETE, 0, Get_Float_Parameter("unloadTime") );
     DockedAtRefinery(obj);
   }
 
 
   // Message to ourselves to indicate ore unloading is complete, grant money
   // to the team and set off to collect some more ore
-  else if ( type == CUSTOM_MINER_UNLOAD_ORE_COMPLETE )
+	if ( type == CUSTOM_MINER_UNLOAD_ORE_COMPLETE )
   {
     // Inform the driver that we have finished unloading
     if ( Get_Vehicle_Driver(obj) != NULL )
     {
       StringClass message(true);
-      message.Format ("Ore unloaded successfully, you have earned %d credits for each player and %d points for yourself", m_oreValue, m_oreValue/10 );
+			message.Format ("Ore unloaded successfully, you have earned %d credits for each player and %d points for yourself", oreValue, oreValue/10 );
       Send_Message_Player ( Get_Vehicle_Driver(obj), DP88_RGB_GENERAL_MSG, message );
-      Commands->Give_Points(Get_Vehicle_Driver(obj),(float)m_oreValue/10.0f,false);
+			Commands->Give_Points(Get_Vehicle_Driver(obj),(float)oreValue/10.0f,false);
     }
 
     // Grant money to team and reset ore load level
-    Commands->Give_Money ( obj, (float)m_oreValue, true );
-    m_oreMined = 0;
-    m_oreValue = 0;
+		Commands->Give_Money ( obj, (float)oreValue, true );
+		oreLoadLevel = 0;
+		oreValue = 0;
 
     // Call UndockedFromRefinery
     UndockedFromRefinery(obj);
   }
-
-
-  // AI message to search for an ore field...
-  else if ( type == CUSTOM_MINER_AI_SEARCH_FOR_ORE )
-  {
-    DriveToOreField(obj);
-  }
 }
 
-// -------------------------------------------------------------------------------------------------
 
-void dp88_Ore_Miner::Action_Complete ( GameObject *obj, int action_id, ActionCompleteReason complete_reason )
+void dp88_AR_Miner::Action_Complete ( GameObject *obj, int action_id, ActionCompleteReason complete_reason )
 {
   // If the completed action was RETURN_TO_REFINERY then set the AI state to
   // docking and call DockAtRefinery();
   if ( action_id == MINER_ACTIONID_RETURN_TO_REFINERY )
   {
-    //Console_Output ( "dp88_Ore_Miner: Arrived at refinery... start docking\n" );
-    m_aiState = MINER_AISTATE_DOCK_AT_REFINERY;
+		//Console_Output ( "dp88_AR_Miner: Arrived at refinery... start docking\n" );
+		aiState = MINER_AISTATE_DOCK_AT_REFINERY;
     DockAtRefinery(obj);
   }
 }
 
-// -------------------------------------------------------------------------------------------------
 
-void dp88_Ore_Miner::DriveToOreField ( GameObject *obj )
+void dp88_AR_Miner::DriveToOreField ( GameObject *obj )
 {
-  m_aiState = MINER_AISTATE_SEARCH_FOR_ORE;
-
-  // \todo Check number of units available in an ore field and find one with a sufficient quantity - 
-  //       ideally 1.5x our capacity to avoid it being depleted before we get there!
-  SList<GameObject> oreFields;
-  Find_All_Objects_With_Script_By_Distance ( "dp88_Ore_Field", oreFields, Commands->Get_Position(obj));
-
-  for ( SLNode<GameObject>* oreFieldNode = oreFields.Head(); oreFieldNode != NULL; oreFieldNode = oreFieldNode->Next() )
-  {
-    if ( GameObject* oreField = oreFieldNode->Data() )
+	/* Find and drive to an ore field */
+	GameObject* zone = Find_Closest_Object_With_Script("dp88_AR_Ore_Field_Zone", Commands->Get_Position(obj));
+	if ( zone != NULL )
     {
-      dp88_Ore_Field* pOreFieldScript = (dp88_Ore_Field *)(Find_Script_On_Object(oreField,"dp88_Ore_Field"));
-      if ( !pOreFieldScript || (!pOreFieldScript->IsInfinite() && pOreFieldScript->NumOreUnits() < 15) )    // 15 is a magic number currently, should fix...
-        continue;
-
-      Vector3 position = Commands->Get_Position(oreField);
-      //Console_Output ( "dp88_Ore_Miner: Driving to location: %.2f, %.2f, %.2f\n", position.X, position.Y, position.Z );
+		Vector3 position = Commands->Get_Position(zone);
+		//Console_Output ( "dp88_AR_Miner: Driving to location: %.2f, %.2f, %.2f\n", position.X, position.Y, position.Z );
 
       /* Setup parameters and get going! */
-      m_aiState = MINER_AISTATE_DRIVE_TO_ORE;
       ActionParamsStruct params;
       params.Set_Basic( this, 100.0f, MINER_ACTIONID_DRIVE_TO_ORE );
       params.Set_Movement ( position, 1.0f, 1.0f );
@@ -1054,81 +1027,51 @@
       params.ShutdownEngineOnArrival = true;
       params.AttackActive = false;
       Commands->Action_Goto( obj, params );
-
-      return;
-    }
   }
-
-  // No ore fields are available at the moment... send ourselves a message to have another look in 5 seconds...
-  Commands->Send_Custom_Event( obj, obj, CUSTOM_MINER_AI_SEARCH_FOR_ORE, 1, (float)5.0f );
 }
 
-// -------------------------------------------------------------------------------------------------
 
-void dp88_Ore_Miner::EnteredOreField ( GameObject *obj, GameObject* oreField )
+void dp88_AR_Miner::EnteredOreField ( GameObject *obj, GameObject* oreField )
 {
-  // Ignore this if we are already full
-  if ( m_oreMined >= m_oreCapacity )
-    return;
-
-  // Check if this is a valid ore field
-  dp88_Ore_Field* pOreFieldScript = (dp88_Ore_Field *)(Find_Script_On_Object(oreField,"dp88_Ore_Field"));
-  if ( !pOreFieldScript )
-    return;
+  // If we are using AI then reset the action now that we have arrived
+  if ( useAI )
+    Commands->Action_Reset ( obj, 101.0f );
 
-  // Set AI state, notify driver or abort if neither AI controlled nor player driven...
-  if ( m_bUseAI )
+  // Start the mining animation if it is not already running
+  if ((strlen(Get_Parameter("miningAnimation")) > 0) && !animating)
   {
-    m_aiState = MINER_AISTATE_COLLECTING_ORE;
-    Commands->Action_Reset ( obj, 101.0f );
+    animating = true;
+    Commands->Set_Animation(obj,Get_Parameter("miningAnimation"),true,0,0,-1,false);
   }
-  else if ( Get_Vehicle_Driver(obj) != NULL )
-    Send_Message_Player ( Get_Vehicle_Driver(obj), DP88_RGB_GENERAL_MSG, "Collecting ore..." );
-  else
-    return;
-
-  // Save the ore field ID and generate a random integer to identify this trip into the ore field
-  // to prevent glitching the timers by entering and exiting constantly
-  m_oreFieldId    = Commands->Get_ID(oreField);
-  m_oreFieldRand  = Commands->Get_Random_Int(2,10240);
-
-  // Send delayed message to increase ore load
-  Commands->Send_Custom_Event ( obj, obj, CUSTOM_MINER_INCREASE_ORE_LOAD, m_oreFieldRand, m_oreMiningTime );
-
-  UpdateAnimation(obj, MINER_ANIM_MINING);
 }
 
-// -------------------------------------------------------------------------------------------------
 
-void dp88_Ore_Miner::ExitedOreField ( GameObject *obj, GameObject* oreField )
+void dp88_AR_Miner::ExitedOreField ( GameObject *obj, GameObject* oreField )
 {
-  // Reset ore field parameters
-  m_oreFieldId    = 0;
-  m_oreFieldRand  = 0;
-
   // Stop the mining animation
-  UpdateAnimation(obj, MINER_ANIM_IDLE);
+  animating = false;
+  obj->As_PhysicalGameObj()->Clear_Animation();
+  if (strlen(Get_Parameter("idleAnimation")) > 0)
+    Commands->Set_Animation(obj,Get_Parameter("idleAnimation"),true,0,0,-1,false);
 
   // If this is an AI miner and our state is still collecting ore then we were probably shoved out
   // of the ore field by some bully in a vehicle so drive back in to finish mining
-  if ( m_bUseAI && m_aiState == MINER_AISTATE_COLLECTING_ORE )
+  if ( useAI && aiState == MINER_AISTATE_COLLECTING_ORE )
     DriveToOreField(obj);
 }
 
-// -------------------------------------------------------------------------------------------------
 
-void dp88_Ore_Miner::ReturnToRefinery ( GameObject *obj )
+void dp88_AR_Miner::ReturnToRefinery ( GameObject *obj )
 {
   /* Find and drive to the refinery */
-  m_aiState = MINER_AISTATE_RETURN_TO_REFINERY;
   GameObject *refinery = Find_Refinery(Commands->Get_Player_Type(obj));
   if ( refinery != NULL )
   {
-    GameObject* zone = Find_Closest_Object_With_Script("dp88_Ore_Dump_Zone", Commands->Get_Position(refinery));
+		GameObject* zone = Find_Closest_Object_With_Script("dp88_AR_Ore_Deposit_Zone", Commands->Get_Position(refinery));
     if ( zone != NULL )
     {
       Vector3 position = Commands->Get_Position(zone);
-      //Console_Output ( "dp88_Ore_Miner: Driving to location: %.2f, %.2f, %.2f\n", position.X, position.Y, position.Z );
+			//Console_Output ( "dp88_AR_Miner: Driving to location: %.2f, %.2f, %.2f\n", position.X, position.Y, position.Z );
 
       /* Setup parameters and get going! */
       ActionParamsStruct params;
@@ -1142,19 +1085,18 @@
   }
 }
 
-// -------------------------------------------------------------------------------------------------
 
-void dp88_Ore_Miner::DockAtRefinery ( GameObject *obj )
+void dp88_AR_Miner::DockAtRefinery ( GameObject *obj )
 {
   // Reset current action
   Commands->Action_Reset(obj, 101.0f);
 
   /* Find and drive to the refinery unloading area */
-  GameObject* zone = Find_Closest_Object_With_Script("dp88_Ore_Dump_Zone", Commands->Get_Position(obj));
+	GameObject* zone = Find_Closest_Object_With_Script("dp88_AR_Ore_Deposit_Zone", Commands->Get_Position(obj));
   if ( zone != NULL )
   {
     Vector3 position = Commands->Get_Position(zone);
-    //Console_Output ( "dp88_Ore_Miner: Docking at location: %.2f, %.2f, %.2f\n", position.X, position.Y, position.Z );
+		//Console_Output ( "dp88_AR_Miner: Docking at location: %.2f, %.2f, %.2f\n", position.X, position.Y, position.Z );
 
     /* Setup parameters and get going! */
     ActionParamsStruct params;
@@ -1167,14 +1109,17 @@
   }
 }
 
-// -------------------------------------------------------------------------------------------------
 
-void dp88_Ore_Miner::DockedAtRefinery ( GameObject *obj )
+void dp88_AR_Miner::DockedAtRefinery ( GameObject *obj )
 {
-  UpdateAnimation(obj, MINER_ANIM_DUMPING);
+	// Start dock animation and sound
+	if (strlen(Get_Parameter("dockAnimation")) > 0)
+		Commands->Set_Animation(obj,Get_Parameter("dockAnimation"),false,0,0,-1,false);
+	if (strlen(Get_Parameter("dockSound")) > 0)
+		Commands->Create_Sound(Get_Parameter("dockSound"),Commands->Get_Position(obj),obj);
 
   // If we are using AI then reset the action now that we have arrived
-  if (m_bUseAI)
+	if (useAI)
     Commands->Action_Reset ( obj, 101.0f );
 
   // Immobilize the vehicle and disable engine sounds
@@ -1185,9 +1130,8 @@
   }
 }
 
-// -------------------------------------------------------------------------------------------------
 
-void dp88_Ore_Miner::UndockedFromRefinery ( GameObject *obj )
+void dp88_AR_Miner::UndockedFromRefinery ( GameObject *obj )
 {
   // Un-immobilize the vehicle and enable engine sounds
   if ( obj->As_VehicleGameObj() )
@@ -1197,52 +1141,16 @@
   }
 
   // If using the AI then set the AI state and start driving to the ore field
-  if ( m_bUseAI )
+	if ( useAI )
   {
+		aiState = MINER_AISTATE_DRIVE_TO_ORE;
     DriveToOreField(obj);
   }
-
-  UpdateAnimation(obj, MINER_ANIM_IDLE);
-}
-
-// -------------------------------------------------------------------------------------------------
-
-void dp88_Ore_Miner::UpdateAnimation ( GameObject* pObj, MINER_ANIMID animId )
-{
-  if ( animId == m_currentAnimId )
-    return;
-
-  pObj->As_PhysicalGameObj()->Clear_Animation();
-
-  if ( animId < sizeof(m_animations) && m_animations[animId] != NULL )
-  {
-    bool bLooping = (animId == MINER_ANIM_DUMPING) ? true : false;
-    Commands->Set_Animation(pObj,m_animations[animId],bLooping,0,0,-1,false);
-  }
-
-  if ( animId < sizeof(m_animSounds) && m_animSounds[animId] != NULL && animId != MINER_ANIM_DUMPING )
-    Commands->Create_Sound(m_animSounds[animId],Commands->Get_Position(pObj),pObj);
+	obj->As_PhysicalGameObj()->Clear_Animation();
+	if (strlen(Get_Parameter("idleAnimation")) > 0)
+		Commands->Set_Animation(obj,Get_Parameter("idleAnimation"),true,0,0,-1,false);
 }
 
-// -------------------------------------------------------------------------------------------------
-
-ScriptRegistrant<dp88_Ore_Miner> dp88_Ore_Miner_Registrant(
-  "dp88_Ore_Miner",
-  "Use_AI=1:int,"
-  "Ore_Capacity=10:int,"
-  "Ore_Mining_Time=2.0:float,"
-  "Ore_Dump_Time=8.0:float,"
-  "AI_Init_Delay=10:int,"
-  "Dump_Animation:string,"
-  "Dump_Sound:string,"
-  "Mining_Animation:String,"
-  "Mining_Sound:string,"
-  "Idle_Animation:string"
-);
-
-
-
-
 
 
 
@@ -1252,27 +1160,25 @@
 
 void dp88_AR_Chrono_Miner::Created( GameObject *obj )
 {
-  dp88_Ore_Miner::Created(obj);
+	dp88_AR_Miner::Created(obj);
   objectId = Commands->Get_ID(obj);
   driverId = NULL;
 }
 
-// -------------------------------------------------------------------------------------------------
 
 void dp88_AR_Chrono_Miner::Damaged( GameObject *obj, GameObject *damager, float amount )
 {
   // If AI miner health drops below the emergency chronoshift health threshold and we are driving to
   // the ore field or collecting ore then begin an emergency chronoshift
-  if ( m_bUseAI && Commands->Get_Health(obj) < (Commands->Get_Max_Health(obj)*(Get_Float_Parameter("emergencyChronoshiftHealthThreshold")/100.0f))
-    && (m_aiState == MINER_AISTATE_COLLECTING_ORE && m_oreMined > 0) )
+	if ( useAI && Commands->Get_Health(obj) < (Commands->Get_Max_Health(obj)*(Get_Float_Parameter("emergencyChronoshiftHealthThreshold")/100.0f))
+		&& (aiState == MINER_AISTATE_COLLECTING_ORE && oreLoadLevel > 0) )
   {
-    // Attempt to start a chronoshift - if it fails don't bother with anything else, driving away
-    // won't help...
+		// Attempt to start a chronoshift - if it fails don't bother
+		// with anything else, driving away won't help...
     Start_Chronoshift(obj);
   }
 }
 
-// -------------------------------------------------------------------------------------------------
 
 void dp88_AR_Chrono_Miner::Custom( GameObject *obj, int type, int param, GameObject *sender )
 {
@@ -1294,7 +1200,7 @@
   
   // AI miner failed to chronoshift back to the refinery, if we are still more than 150m
   // from the target then try again
-  else if ( type == CUSTOM_CHRONO_MINER_RETRY_CHRONOSHIFT && m_aiState == MINER_AISTATE_RETURN_TO_REFINERY )
+	else if ( type == CUSTOM_CHRONO_MINER_RETRY_CHRONOSHIFT && aiState == MINER_AISTATE_RETURN_TO_REFINERY )
   {
     GameObject *refinery = Find_Refinery(Commands->Get_Player_Type(obj));
     if ( refinery != NULL && Commands->Get_Distance(Commands->Get_Position(refinery),Commands->Get_Position(obj)) > 150.0f )
@@ -1315,10 +1221,9 @@
 
   // Otherwise pass the message on to the base class
   else
-    dp88_Ore_Miner::Custom ( obj, type, param, sender );
+		dp88_AR_Miner::Custom ( obj, type, param, sender );
 }
 
-// -------------------------------------------------------------------------------------------------
 
 void dp88_AR_Chrono_Miner::KeyHook()
 {
@@ -1327,14 +1232,13 @@
   if ( !obj )
     return;
 
-  if ( m_aiState != CMINER_AISTATE_CHRONOSHIFTING )
+	if ( aiState != CMINER_AISTATE_CHRONOSHIFTING )
   {
     if ( !Start_Chronoshift(obj) )
       Send_Message_Player ( Get_Vehicle_Driver(obj), 153, 204, 25, "Unable to chronoshift, all target zones are unavailable..." );
   }
 }
 
-// -------------------------------------------------------------------------------------------------
 
 void dp88_AR_Chrono_Miner::ReturnToRefinery ( GameObject *obj )
 {
@@ -1342,7 +1246,7 @@
   if ( !Start_Chronoshift(obj) )
   {
     // Can't chronoshift... drive there instead!
-    dp88_Ore_Miner::ReturnToRefinery(obj);
+		dp88_AR_Miner::ReturnToRefinery(obj);
     Send_Message_Team ( Get_Object_Type(obj), 153, 204, 25, "The AI Chronominer was unable to chronoshift, please clear the area around the refinery" );
 
     // Send a delayed custom to retry the chronoshift in 5 seconds
@@ -1350,12 +1254,11 @@
   }
 }
 
-// -------------------------------------------------------------------------------------------------
 
 bool dp88_AR_Chrono_Miner::Start_Chronoshift( GameObject *obj )
 {
   // If we are currently chronoshifting then bail out
-  if ( m_aiState == CMINER_AISTATE_CHRONOSHIFTING )
+	if ( aiState == CMINER_AISTATE_CHRONOSHIFTING )
     return false;
 
   /* Find a zone to chronoshift in to */
@@ -1367,26 +1270,56 @@
     if ( Commands->Get_Health(refinery) == 0 )
       return false;
 
+		SList<GameObject> chronoZones;
+		Find_All_Objects_With_Script ( "dp88_AR_Chrono_Miner_Chronozone", chronoZones );
+
+		GameObject* zone = NULL;
+		dp88_AR_Chrono_Miner_Chronozone *chronozone_script = NULL;
+
     // Define the maximum distance we will shift from the refinery - this prevents us
     // from going to the enemy refinery
     const float maxDist = 50.0f;
-    Vector3 refineryPos = Commands->Get_Position(refinery);
 
-    SList<GameObject> chronoZones;
-    Find_All_Objects_With_Script_By_Distance ( "dp88_AR_Chrono_Miner_Chronozone", chronoZones, refineryPos );
+		// Search for the closest zone which we can chronoshift to
+		Vector3 pos = Commands->Get_Position(refinery);
+		while ( zone == NULL && !chronoZones.Is_Empty() )
+		{
+			float closestdist = 0.0f;
 
-    for ( SLNode<GameObject>* x = chronoZones.Head(); x != NULL; x = x->Next() )
+			// Find the closest zone
+			SLNode<GameObject> *x = chronoZones.Head();
+			while (x)
     {
-      GameObject* zone = x->Data();
-      dp88_AR_Chrono_Miner_Chronozone *chronozone_script = NULL;
+				GameObject *o = x->Data();
+				x = x->Next();
+
+				float dist = Commands->Get_Distance(Commands->Get_Position(o),pos);
+				if ( dist > maxDist )
+					chronoZones.Remove(o);
+
+				else if (zone == NULL || dist < closestdist)
+				{
+					closestdist = dist;
+					zone = o;
+				}
+			}
 
       if ( !zone )
-        continue;
+				break;
+
+			// OK, got the closest... can we chronoshift there?
 
-      // OK, got a candidate zone, can we chronoshift here?
-      Vector3 zonePos = Commands->Get_Position(zone);
-      if ( Commands->Get_Distance(zonePos,refineryPos) > maxDist || !CanChronoshiftToLocation(obj, zonePos) )
-        continue;
+			// Get physical game object and moveable phys class references (used to check if we can move to the zone)
+			MoveablePhysClass* mphys = ( obj->As_PhysicalGameObj() ) ? obj->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass() : NULL;
+
+			// Can we move to this position without getting stuck?
+			if ( !mphys->Can_Teleport( Matrix3D( Commands->Get_Position(zone)) ) )
+			{
+				// Nope, we can't... eliminate this zone from the list of possibilities and
+				// loop around for another try
+				chronoZones.Remove(zone);
+				zone = NULL;
+			}
 
       // Is this zone in use for another chronoshift operation? If so then we cannot use it
       chronozone_script = (dp88_AR_Chrono_Miner_Chronozone*)Find_Script_On_Object(zone, "dp88_AR_Chrono_Miner_Chronozone");
@@ -1394,16 +1327,26 @@
                     && Commands->Find_Object(chronozone_script->chronominer_id)
                     && Commands->Get_Health(Commands->Find_Object(chronozone_script->chronominer_id)) > 0) )
       {
-        continue;
+				// Yes, it's in use... eliminate this zone from the list of possibilities and
+				// loop around for another try
+				chronoZones.Remove(zone);
+				chronozone_script = NULL;
+				zone = NULL;
+			}
       }
 
 
-      // OK, got ourselves a target zone, lock the zone to our ID and set up for chronoshift...
+		// If we failed to find a suitable target zone bail out
+		if ( !zone )
+			return false;
+
+		// Set the chronominer_id of the script zone to our own ID to prevent other
+		// miners trying to use it
       chronozone_script->chronominer_id = Commands->Get_ID(obj);
 
       // NB: We use the AI state flag to determine if we are currently in the middle of
       // a chronoshift for player driven miners too
-      m_aiState = CMINER_AISTATE_CHRONOSHIFTING;
+		aiState = CMINER_AISTATE_CHRONOSHIFTING;
     
       // Immobilise the vehicle
       if ( obj->As_VehicleGameObj() )
@@ -1440,12 +1383,10 @@
 
       return true;
     }
-  }
 
   return false;
 }
 
-// -------------------------------------------------------------------------------------------------
 
 void dp88_AR_Chrono_Miner::Do_Chronoshift( GameObject *obj, int target_zone_id )
 {
@@ -1457,90 +1398,42 @@
   GameObject *zone = Commands->Find_Object(target_zone_id);
   if ( zone != NULL )
   {
-    // NB: We use the AI state flag to determine if we are currently in the middle
-    // of a chronoshift for player driven miners too
-    m_aiState = MINER_AISTATE_IDLE;
-
     // Get a reference to the chronozone script and check if the chronominer_id
     // matches ours. If so zero it and continue, otherwise bail out...
     dp88_AR_Chrono_Miner_Chronozone *chronozone_script = (dp88_AR_Chrono_Miner_Chronozone*)Find_Script_On_Object(zone, "dp88_AR_Chrono_Miner_Chronozone");
     if ( !chronozone_script || chronozone_script->chronominer_id != Commands->Get_ID(obj) )
-    {
-      // Have another go at a chronoshift...
-      ReturnToRefinery(obj);
       return;
-    }
 
     chronozone_script->chronominer_id = 0;
 
+		// NB: We use the AI state flag to determine if we are currently in the middle
+		// of a chronoshift for player driven miners too
+		aiState = MINER_AISTATE_IDLE;
+
     // Chronoshift to position of zone (resetting rotation in the process)
-    Vector3 zonePos = Commands->Get_Position(zone);
-    if ( CanChronoshiftToLocation(obj, zonePos) )
-      Set_Transform(obj, Matrix3D(zonePos) );
-    else
-    {
-      // Oh noes! Some dipstick has driven into the chronoshift zone... try again
-      ReturnToRefinery(obj);
-      return;
-    }
+		Set_Transform(obj, Matrix3D(Commands->Get_Position(zone)) );
   }
 
 
   /* If using AI start driving to refinery now */
-  if ( m_bUseAI )
+	if ( useAI )
   {
-    if ( m_oreMined > 0 )
+		if ( oreLoadLevel > 0 )
     {
-      dp88_Ore_Miner::ReturnToRefinery(obj);
+			aiState = MINER_AISTATE_RETURN_TO_REFINERY;
+			dp88_AR_Miner::ReturnToRefinery(obj);
     }
 
     // No ore collected... guess we must have chronoshifted away from an attack
     // so lets set off towards the ore field again... what a waste of time!
     else
     {
-      DriveToOreField(obj);
-    }
+			aiState = MINER_AISTATE_DRIVE_TO_ORE;
+			dp88_AR_Miner::DriveToOreField(obj);
   }
 }
-
-// -------------------------------------------------------------------------------------------------
-
-bool dp88_AR_Chrono_Miner::CanChronoshiftToLocation ( GameObject* obj, Vector3& location )
-{
-  // Get physical game object and moveable phys class references
-  MoveablePhysClass* mphys = ( obj->As_PhysicalGameObj() ) ? obj->As_PhysicalGameObj()->Peek_Physical_Object()->As_MoveablePhysClass() : NULL;
-
-  // Can we move to this position without getting stuck?
-  return mphys->Can_Teleport( Matrix3D(location) );
 }
 
-// -------------------------------------------------------------------------------------------------
-
-ScriptRegistrant<dp88_AR_Chrono_Miner> dp88_AR_Chrono_Miner_Registrant(
-  "dp88_AR_Chrono_Miner",
-  "Use_AI=1:int,"
-  "chronoshift_time=2.5:float,"
-  "chronoshift_out_effect_preset:string,"
-  "chronoshift_out_effect_time:float,"
-  "chronoshift_in_effect_preset:string,"
-  "chronoshift_in_effect_time:float,"
-  "chronoshiftKeyhook=VDeploy:string,"
-  "Ore_Capacity=5:int,"
-  "Ore_Mining_Time=1.00:float,"
-  "Ore_Dump_Time=4.0:float,"
-  "emergencyChronoshiftHealthThreshold=30.0:float,"
-  "AI_Init_Delay=10:int,"
-  "Dump_Animation:string,"
-  "Dump_Sound:string,"
-  "Mining_Animation:String,"
-  "Mining_Sound:string,"
-  "Idle_Animation:string"
-);
-
-
-
-
-
 
 
 
